# -*- coding: utf-8 -*-
"""
Created on Wed Dec 16 15:02:45 2020

@author: Studente

Write a recursive function that takes as an input the pathname of
a directory and returns a pair with the number of files and
subdirectories reachable from the given directory.
"""

import os

def count_file_n_dirs(pathname):
    fcount= dcount = 0
    for fname in os.listdir(pathname):
        if os.path.isfile(os.path.join(pathname, fname)):
            fcount += 1
        elif os.path.isdir(os.path.join(pathname, fname)):
            subfcount, subdcount = count_file_n_dirs(os.path.join(pathname, fname))
            fcount += subfcount
            dcount += 1 + subdcount
    return fcount, dcount    
    