# -*- coding: utf-8 -*-
"""
Created on Wed Dec 16 13:19:15 2020

@author: Studente
Write a recursive function gen_random_tree(n, a, b) that generates a random binary tree with n nodes, where each node has a random value in the range (a,b)

"""

from bintree import BinTree
from random import randint

def gen_random_tree(n, a, b, root = None, free = None):
    if n == 0:
        return root
    if root == None:
        root = BinTree(randint(a,b))
        free = [(root, 0), (root, 1)]
    else:
        node, side = free.pop(randint(0,len(free)-1))
        new_node = BinTree(randint(a,b))
        free.extend([(new_node,0), (new_node,1)])
        if side:
            node.right = new_node
        else:
            node.left = new_node
    return gen_random_tree(n-1, a,b,root,free)    


def gen_random_tree2(n, a,b):
    if n == 0:
        return None
    root = BinTree(randint(a,b))
    n-=1
    root.left = gen_random_tree2(n//2+ (n%2), a,b)
    root.right = gen_random_tree2(n//2, a,b)
    return root
    
def new_node_if_none(tree,a,b):
    choice = randint(0,1)
    if choice:
        if tree.left == None:
            tree.left = BinTree(randint(a,b))
        else:
            new_node_if_none(tree.left,a,b)
    else:
        if tree.right == None:
            tree.right = BinTree(randint(a,b))
        else:
            new_node_if_none(tree.right,a,b)


def gen_random_tree3(n, a, b):
    root = BinTree(randint(a,b))
    for _ in range(n-1):
        new_node_if_none(root,a,b)
    return root
    
    
    